package com.example.audiovisualrecord;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.graphics.Bitmap;
import android.net.Uri;
import android.provider.MediaStore;
import android.util.Log;

import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import static android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI;


public class HDMediaStore {
    public static String insertImage(ContentResolver cr, Bitmap source,
                                     String title, String description) {
        Calendar calendar = Calendar.getInstance();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd_hhmm");
        String timeName = dateFormat.format(calendar.getTime());
        ContentValues values = new ContentValues();
        values.put(MediaStore.Images.Media.TITLE, title);
        values.put(MediaStore.MediaColumns.DISPLAY_NAME, timeName);
        values.put(MediaStore.MediaColumns.BUCKET_DISPLAY_NAME, timeName);
        values.put(MediaStore.Images.Media.MIME_TYPE, "image/jpg");

        Uri url = null;
        String stringUrl = null;    /* value to be returned */

        try {
            url = cr.insert(EXTERNAL_CONTENT_URI, values);

            if (source != null) {
                OutputStream imageOut = cr.openOutputStream(url);
                try {
                    source.compress(Bitmap.CompressFormat.JPEG, 100, imageOut);
                } finally {
                    imageOut.close();
                }

                long id = ContentUris.parseId(url);
                // Wait until MINI_KIND thumbnail is generated.
            } else {
                Log.e("kkk", "Failed to create thumbnail, removing original");
                cr.delete(url, null, null);
                url = null;
            }
        } catch (Exception e) {
            Log.e("kkk", "Failed to insert image", e);
            if (url != null) {
                cr.delete(url, null, null);
                url = null;
            }
        }

        if (url != null) {
            stringUrl = url.toString();
        }

        return stringUrl;
    }

}

